#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

float expression(void);
float term(void);
float number(void);
float primary(void);

char* p=NULL;
char* prog=NULL;

void skipspace(){
   while((*p==' ' || *p=='\t') && *p!='\0'){
      p++;
   }
}

float number(void){
   char* s;
   char* endptr;
   float result;
   long l = 0;
   s = new char[strlen(p)];

   skipspace();
   while( isdigit(*p) || *p=='-' || *p=='+' || *p=='e' || *p=='E' || *p=='.'){
       s[l] = *p;
       p++;
       l++;
   }

   s[l]='\0';
   result = strtod(s, &endptr);

   while(*endptr != '\0'){
       l--;
       p--;
       s[l]='\0';
       result = strtod(s, &endptr);
   }

   delete [] s;
   return(result);
}

float primary(void){
   float result;

   skipspace();
   if(*p=='('){
      p++;
      result = expression();
      p++;
   }
   else{
      result = number();
   }
   return(result);
}

float term(void){
   float result = 0;

   result = primary();
   skipspace();
   while(*p=='*' || *p=='/'){
       if(*p=='*'){
	   p++;
	   result *= primary();
	   skipspace();
       }
       else{
	   p++;
	   result /= primary();
	   skipspace();
       }
   }
   return(result);
}

float expression(void){
   float result = 0;
   skipspace();
   if(*p=='-'){
       p++;
       result = -term();
   }
   else{
       if(*p=='+'){
	   p++;
       }
       result = term();
   }
   while(*p=='+' || *p=='-'){
       if(*p=='+'){
	   p++;
	   result = result + term();
       }
       else{
	   p++;
	   result = result - term();
       }
   }
   return(result);
}

void init(){
   long len=0;
   FILE* InFile;
   InFile = fopen("1.bas", "rt");

   //what is length of file?
   fseek(InFile, 0, SEEK_END);
   len = ftell(InFile);

   //get memory for program
   prog = new char[len+1];
   p = prog;
   if(p==NULL){
       printf("\nNot enough memory for program loading.\n");
       return;
   }

   //read program
   fseek(InFile, 0, SEEK_SET);
   fread(p, 1, len, InFile);
   p[len]='\0';
   fclose(InFile);
}

void final(){
   delete [] prog;
}

void main(){
   float result=0;

   //initalize p - get memory for program
   init();

   //calculate result
   result = expression();

   //release program memory
   final();

   printf("\n%lf\n", result);
}